/* Asteroids3D - a first person game of blowing up asteroids
 * Copyright (C) 2000 Stuart Mark Pomerantz
 *
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 *  Stuart Pomerantz
 *  3935 Stonecliffe drive
 *  Monroeville, PA 15146
 *  stuart@pitt.edu
 */

#include "asteroids3D.h"



void init_dust(void) {
	extern vector dust_part[NUM_DUST_PART][NUM_CHILD_DUST_PART] ;
	int i,j ;
	
	srand(time(NULL)) ;
	
	for( i = 0 ; i < NUM_DUST_PART ; i++) {
		dust_part[i][0].x = gen_rand_float( -ABOUND,ABOUND ) ;
	 	dust_part[i][0].y = gen_rand_float( -ABOUND,ABOUND ) ;
		dust_part[i][0].z = gen_rand_float( -ABOUND,ABOUND ) ;
	 
	 	for( j = 1 ; j < NUM_CHILD_DUST_PART ; j++ ) {
			dust_part[i][j].x = gen_rand_float( -CHILD_DUST_PART_DELTA,CHILD_DUST_PART_DELTA ) ;
			dust_part[i][j].y = gen_rand_float( -CHILD_DUST_PART_DELTA,CHILD_DUST_PART_DELTA ) ;
			dust_part[i][j].z = gen_rand_float( -CHILD_DUST_PART_DELTA,CHILD_DUST_PART_DELTA ) ;
		}
	}
	
	return ;
}


void process_dust(void) {
	extern vector dust_part[NUM_DUST_PART][NUM_CHILD_DUST_PART] ;
	extern vector pos ;
	int i ;
	
		
		/* wrap the dust around player */
	for( i = 0 ; i < NUM_DUST_PART ; i++) {		
		if( dust_part[i][0].x > pos.x + ABOUND )
			dust_part[i][0].x = pos.x - ABOUND + 10 ;

		if( dust_part[i][0].x < pos.x - ABOUND )
			dust_part[i][0].x = pos.x + ABOUND - 10 ;


		if( dust_part[i][0].y > pos.y + ABOUND )
			dust_part[i][0].y = pos.y - ABOUND + 10 ;

		if( dust_part[i][0].y < pos.y - ABOUND )
			dust_part[i][0].y = pos.y + ABOUND - 10 ;


		if( dust_part[i][0].z > pos.z + ABOUND )
			dust_part[i][0].z = pos.z - ABOUND + 10 ;

		if( dust_part[i][0].z < pos.z - ABOUND )
			dust_part[i][0].z = pos.z + ABOUND - 10 ;
	}
	
	return ;
}
