/* Asteroids3D - a first person game of blowing up asteroids
 * Copyright (C) 2000 Stuart Mark Pomerantz
 *
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 *  Stuart Pomerantz
 *  3935 Stonecliffe drive
 *  Monroeville, PA 15146
 *  stuart@pitt.edu
 */
 
#include "asteroids3D.h"


/* generate new asteroids at position pos smaller then type */
void add_new_asteroids( vector pos, int type) {
	extern node *al_tail ;
	node *current = NULL ;	
	int num_new_rocks ;
	int i;


	/* decide how many new rocks to generate. Wieghted to be 2 or 3 */	

	/* srand(time(NULL)) ; */
	
	i = gen_rand_int(0, 9) ; /* FIXME after gen_rand_int is fixed */

	switch(i) {
		case 0:
			num_new_rocks = 2 ;
			break;
		case 1:
			num_new_rocks = 2 ;
			break ;
		case 2:
			num_new_rocks = 2 ;
			break ;
		case 3:
			num_new_rocks = 3 ;
			break ;
		case 4:
			num_new_rocks = 3 ;
			break ;
		case 5:
			num_new_rocks = 3 ;
			break ;
		case 6:
			num_new_rocks = 3 ;
			break ;
		case 7:
			num_new_rocks = 4 ;
			break ;
		case 8:
			num_new_rocks = 4 ;
			break ;
		case 9:
			num_new_rocks = 5 ;
			break ;
		default:
			num_new_rocks = 2 ;
	} 

	current = al_tail ;

	for( i = 0 ; i < num_new_rocks ; i++ ) {
		if( current->next == NULL )
			current->next = add_node() ;

		current = current->next ;
		gen_rand_asteroid_at_pos( pos, &current->rock, type ) ;
	}

	al_tail = current ;	
	
	return ;
}


void gen_rand_asteroid_at_pos(vector pos, asteroid *a, int type) {
	float k ;
	

	a->type = gen_rand_int(0,type-1) ;

	a->mass = MIN_AST_MASS + AST_MASS_K*a->type ;  /* based on type */

	a->radius = 0.5*(float)(a->type+1) ; /* based on type */

	a->pos.x = pos.x ;
	a->pos.y = pos.y ;
	a->pos.z = pos.z ;

	k = gen_rand_float( 0, MAX_APD ) ;		
	gen_rand_uv( &a->velocity ) ;
	a->velocity.x = a->velocity.x*k ;
	a->velocity.y = a->velocity.y*k ;
	a->velocity.z = a->velocity.z*k ;
	
	a->rot = 0 ;           
	a->rot_delta = gen_rand_int(-MAX_ARD, MAX_ARD) ;     

	gen_rand_uv( &a->rot_axis ) ;      

	return ;
} 
