/* Asteroids3D - a first person game of blowing up asteroids
 * Copyright (C) 2000 Stuart Mark Pomerantz
 *
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 *  Stuart Pomerantz
 *  3935 Stonecliffe drive
 *  Monroeville, PA 15146
 *  stuart@pitt.edu
 */
 
#include "asteroids3D.h"

void init_textures(void) {
	extern int ast_tex[NUM_AST_TYPES] ;
	extern int nebula_tex[NUM_NEBULA_TEX] ;
	extern int torp_tex ;
	char *ast_tex0 ;
	char *ast_tex1 ;
	char *ast_tex2 ;
	char *ast_tex3 ;
	char *ast_tex4 ;
	char *ast_tex5 ;
	char *nebula_tex0 ;
	char *nebula_tex1 ;
	char *nebula_tex2 ;		
	char *torp_tex0 ;
	
	/* WARNING! There had better be NUM_AST_TYPES number of textures! */
	
	glGenTextures(1, &ast_tex[0]) ;
	glBindTexture(GL_TEXTURE_2D,ast_tex[0]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE) ;*/
		
	
		ast_tex0 = read_bppm_tex("ast_tex0.ppm", 15, 128, 128) ;
		
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,128,128,0,GL_RGB,GL_UNSIGNED_BYTE,ast_tex0) ;


	glGenTextures(1, &ast_tex[1]) ;
	glBindTexture(GL_TEXTURE_2D,ast_tex[1]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE) ;*/
	
		ast_tex1 = read_bppm_tex("ast_tex1.ppm", 15, 128, 128) ;
		
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,128,128,0,GL_RGB,GL_UNSIGNED_BYTE,ast_tex1) ;


	glGenTextures(1, &ast_tex[2]) ;
	glBindTexture(GL_TEXTURE_2D,ast_tex[2]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE) ;*/
		
	
		ast_tex2 = read_bppm_tex("ast_tex2.ppm", 15, 256, 128) ;
		
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,128,0,GL_RGB,GL_UNSIGNED_BYTE,ast_tex2) ;



	glGenTextures(1, &ast_tex[3]) ;
	glBindTexture(GL_TEXTURE_2D,ast_tex[3]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE) ;*/
		
	
		ast_tex3 = read_bppm_tex("ast_tex3.ppm", 15, 256, 128) ;
		
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,128,0,GL_RGB,GL_UNSIGNED_BYTE,ast_tex3) ;


	glGenTextures(1, &ast_tex[4]) ;
	glBindTexture(GL_TEXTURE_2D,ast_tex[4]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE) ;*/
		
	
		ast_tex4 = read_bppm_tex("ast_tex4.ppm", 15, 128, 128) ;
		
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,128,128,0,GL_RGB,GL_UNSIGNED_BYTE,ast_tex4) ;



	glGenTextures(1, &ast_tex[5]) ;
	glBindTexture(GL_TEXTURE_2D,ast_tex[5]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE) ;*/
		
	
		ast_tex5 = read_bppm_tex("ast_tex5.ppm", 15, 256, 256) ;
		
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,ast_tex5) ;


	/** 
	 ** read in the nice nebula bitmaps 
	 **/

	glGenTextures(1, &nebula_tex[0]) ;
	glBindTexture(GL_TEXTURE_2D,nebula_tex[0]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL) ;*/
		
		nebula_tex0 = read_bppm_tex("nebula_tex0.ppm", 15, 256, 256) ;

		nebula_tex0 = add_alpha_channel_to_RGB_image(nebula_tex0, 256, 256) ;
		
		average_RGBA_alpha_and_floor(nebula_tex0, 256, 256, 90) ;		

		glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,256,256,0,GL_RGBA,GL_UNSIGNED_BYTE,nebula_tex0) ;




	glGenTextures(1, &nebula_tex[1]) ;
	glBindTexture(GL_TEXTURE_2D,nebula_tex[1]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL) ;*/

		nebula_tex1 = read_bppm_tex("nebula_tex1.ppm", 15, 256, 256) ;

		nebula_tex1 = add_alpha_channel_to_RGB_image(nebula_tex1, 256, 256) ;
		
		average_RGBA_alpha_and_floor(nebula_tex1, 256, 256, 90) ;		

		glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,256,256,0,GL_RGBA,GL_UNSIGNED_BYTE,nebula_tex1) ;





	glGenTextures(1, &nebula_tex[2]) ;
	glBindTexture(GL_TEXTURE_2D,nebula_tex[2]) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;
		/*glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL) ;*/

		nebula_tex2 = read_bppm_tex("nebula_tex2.ppm", 15, 256, 256) ;

		nebula_tex2 = add_alpha_channel_to_RGB_image(nebula_tex2, 256, 256) ;
		
		average_RGBA_alpha_and_floor(nebula_tex2, 256, 256, 90) ;		

		glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,256,256,0,GL_RGBA,GL_UNSIGNED_BYTE,nebula_tex2) ;



	/***
	 *** ALPHA BLENDED torpedo billboard texture 
	 ***/

	glGenTextures(1, &torp_tex) ;
	glBindTexture(GL_TEXTURE_2D,torp_tex) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR) ;
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR) ;

		torp_tex0 = read_bppm_tex("torp_tex0.ppm", 15, 128, 128) ;

		torp_tex0 = add_alpha_channel_to_RGB_image(torp_tex0, 128, 128) ;
		
		average_RGBA_alpha_and_floor(torp_tex0, 128, 128, 90) ;		

		glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_RGBA,GL_UNSIGNED_BYTE,torp_tex0) ;



	/* now, bind to the special texture 0 to turn off texturing intially.
	 * This is here because texturing is off by default.
	 */
	 
	glBindTexture(GL_TEXTURE_2D,0) ;


	return ;
}


char *read_bppm_tex(char *name, int h, int x, int y) {
	char *image ;
	int fd, i, j ;
	char c, *pi ;
	
	image = calloc( x*y*3, sizeof(char) );


	fd = open(name,O_RDONLY) ;
	
	/* scan past the header info */
	
	for(i = 0 ; i < h ; i++ ) {
		read(fd,&c,1);
		/* printf("%d -> '%c'\n",i,c) ; */
	}

	pi = image ;
	for( i = y - 1 ; i >= 0 ; i--) {
		pi += i*x*3 ;
		for( j = 0 ; j < x*3 ; j++ ) {
			read( fd, pi, 1) ;
			pi++ ;
		}
		pi = image ;
	}

	return(image) ;
}



char *add_alpha_channel_to_RGB_image(char *image, int x, int y) {
	char *alpha_image ;
	int  alpha = 255 ;
	int i, index ;
	
	alpha_image = calloc( x*y*4, sizeof(char) ) ;

	index = 0 ;
	for( i = 0 ; i < x*y*4 ; i+=4 ) {
		alpha_image[i]   = image[index] ; index++ ;
		alpha_image[i+1] = image[index] ; index++ ;
		alpha_image[i+2] = image[index] ; index++ ;
		alpha_image[i+3] = (char) alpha ;
	}

	free(image) ;

	return(alpha_image) ;
}


/* given and RGBA image of size x*y look for r,g, & b and replace the alpha
 * for that r,g & b with a
 */
void change_alpha_for_RGBA_image(char *image, int x, int y, int r, int g, int b, int a) {
	int i ;
	int ir, ig, ib, ia ;

	for( i = 0 ; i < x*y*4 ; i+= 4 ) {
		
		ir = char2int( image[i]   ) ;
		ig = char2int( image[i+1] ) ;
		ib = char2int( image[i+2] ) ;
		ia = char2int( image[i+3] ) ;
		
		if( (ir == r) && (ig == g) && (ib == b) ) {
			image[i+3] = (char) a ;
		}
				
	}

	return ;
}


/* this guy will average the rgb intensities of a pixel
 * make the alpha value for that pixel that average.
 * this has the effect of making brighter pixels more opaque than
 * darker ones.
 * If the average is below the floor value, then the pixel alpha
 * is set to 0
 */
void average_RGBA_alpha_and_floor(char *image, int x, int y, int floor) {
	int i ;
	int ir, ig, ib, ia ;
	int new_alpha ;
	
	for( i = 0 ; i < x*y*4 ; i+= 4 ) {
		
		ir = char2int( image[i]   ) ;
		ig = char2int( image[i+1] ) ;
		ib = char2int( image[i+2] ) ;
		ia = char2int( image[i+3] ) ;
		
		new_alpha = (ir+ig+ib)/3 ; 
		
		if( new_alpha < floor ) 
			new_alpha = 0 ;
		
		image[i+3] = (char) new_alpha ;				
	}

	return ;
}
