/* Asteroids3D - a first person game of blowing up asteroids
 * Copyright (C) 2000 Stuart Mark Pomerantz
 *
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 *  Stuart Pomerantz
 *  3935 Stonecliffe drive
 *  Monroeville, PA 15146
 *  stuart@pitt.edu
 */
 
#include "asteroids3D.h"

void reset_view(void) {
	extern vector xaxis , yaxis , zaxis ;
	extern vector pos ;
	 
	/* initial world position is at the origin */

	pos.x = 0 ; pos.y = 0 ; pos.z = 0 ;
	
	/* initial axes are the standard unit axes */
	
	xaxis.x = 1 ; xaxis.y = 0 ; xaxis.z = 0 ;
	yaxis.x = 0 ; yaxis.y = 1 ; yaxis.z = 0 ;
	zaxis.x = 0 ; zaxis.y = 0 ; zaxis.z = 1 ;

	 

	/* 
	 * for the purposes of this program, the view
	 * is going to be fixed down the POSITIVE z axis
	 */

	glMatrixMode(GL_MODELVIEW) ;
	glLoadIdentity() ;
	gluLookAt(pos.x,         pos.y,         pos.z, 
	          pos.x+zaxis.x, pos.y+zaxis.y, pos.z+zaxis.z,
			  yaxis.x,       yaxis.y,       yaxis.z ) ;



	return ;
}



void rotate_view_aboutx(float a) {
	extern vector xaxis , yaxis, zaxis ;
	float m[16] ;
	
	find_rotation_mat( -a, xaxis, m ) ;

	apply_v2m( &yaxis,m ) ;
	apply_v2m( &zaxis,m ) ;
	
	return ;
}




void rotate_view_abouty(float a) {
	extern vector xaxis , yaxis, zaxis ;
	float m[16] ;
	
	find_rotation_mat( -a, yaxis, m ) ;

	apply_v2m( &xaxis,m ) ;
	apply_v2m( &zaxis,m ) ;
	
	return ;
}


void rotate_view_aboutz(float a) {
	extern vector xaxis , yaxis, zaxis ;
	float m[16] ;
	
	find_rotation_mat( -a, zaxis, m ) ;
	
	apply_v2m( &xaxis,m ) ;
	apply_v2m( &yaxis,m ) ;
	
	return ;
}
